/***************************************************************************
 *                                                                         *
 *   QRYSTG.C                                                              *
 *                                                                         *
 *   Copyright (C) 1995 GALACTICOMM, Inc.    All Rights Reserved.          *
 *                                                                         *
 *   World-Wide Web Query-String handling utilities.                       *
 *                                                                         *
 *   Ref HTML Sourebook, 1995, Ian S. Graham, pages 162-165, 225-227.      *
 *                                                                         *
 *                                              - R. Stein  7/12/95        *
 *                                                                         *
 ***************************************************************************/

#define FILREV "$Revision:   1.0  $"

#include "gcomm.h"
#include "qrystg.h"

short                              /*   returns 1=got 1st, 0=error/no data */
qrs1st(                            /* initialize parsing a query string    */
struct qrsinf *qip,                /*   ptr to query-string info block     */
char *qstring)                     /*   query string (after '?' in uri for */
                                   /*   GET method, body for POST method)  */
                                   /*   (query string hacked up in place)  */
                                   /* Caller should not wait before calling*/
                                   /* qrsnxt() to exhaustion, as strtok()  */
{                                  /* may be used internally.              */
     char *pair;
     char *eqpos;

     if ((pair=strtok(qstring,"&")) == NULL) {
          return(0);
     }
     strrpl(qip->name=pair,'+',' ');
     if ((eqpos=strchr(pair,'=')) == NULL) {
          decurl(pair);
          qip->value="";
          return(1);
     }
     *eqpos++='\0';
     decurl(pair);
     decurl(qip->value=eqpos);
     return(1);
}

short                              /*   returns 1=got more, 0=done/error   */
qrsnxt(                            /* next name/value pair fm query string */
struct qrsinf *qip)                /*   ptr to query-string info block     */
{
     return(qrs1st(qip,NULL));
}

char *                             /*   returns same value as passed       */
decurl(                            /* decode URL escape coding             */
char *url)                         /*   URL string, converted in place     */
                                   /*   (string never expands, may shrink) */

{
     char *ppos;
     int eschar;

     for (ppos=strchr(url,'%') ; ppos != NULL ; ppos=strchr(ppos,'%')) {
          if (isxdigit(ppos[1])
           && isxdigit(ppos[2])
           && sscanf(ppos+1,"%2x",&eschar) == 1) {
               *ppos++=(char)eschar;
               strcpy(ppos,ppos+2);
          }
          else {
               ppos++;
          }
     }
     return(url);
}

